/*<![CDATA[*/
jQuery(function($)
{
	var modifiedExcludeList=true;
	
  getAjaxUrl = function()
  {
    return wpxe_replace_i18n.ajax_url;
  };

	callAjax = function(data, callback)
	{
		$.ajax(
		{
			type: 'POST',  
			url: getAjaxUrl(),  
			data: data,
			success: function(response, textStatus, XMLHttpRequest)
			{
				response = $.parseJSON(response);
				if (response.error)
				{
					alert(response.message)
				}
				else
				{
					callback(response);
				}
			},  
			error: function(MLHttpRequest, textStatus, errorThrown)
			{
				alert(errorThrown);
			}  
		});
	};

	checkUrl = function(url)
	{
		return /^https?:\/\/(www\.)?[a-z0-9\-\.]{2,}\.[a-z]{2,5}$/.test(url);
	};

	updateSearchList = function()
	{
		var btns = $('#wpex-replace-string-tools .list-search-urls .row input.add');
		if (btns.length == 0)
		{
			$('#btnreplaceurls').attr('disabled', true);
			$('#wpex-replace-tab-general .no-found').slideDown('fast', function()
			{
				$(this).removeClass('hidden');
			});
		}
		else
		{
			$('#btnreplaceurls').attr('disabled', false);
		}

		modifiedExcludeList = true;
	};
	
	updateExcludeList = function()
	{
		var btns = $('#wpex-replace-excludeed-urls .row input.remove');
		if (btns.length == 0)
		{
			$('#wpex-replace-tab-excludes .no-found').slideDown('fast', function()
			{
				$(this).removeClass('hidden')
			});
		}
		else
		{
			$('#wpex-replace-tab-excludes .no-found').slideUp('fast', function()
			{
				$(this).addClass('hidden');
			});
		}
	};
		
  $(document).ready(function()
  {
		// create tabs
		$('#wpex-replace-tabs').tabs(
		{
			activate: function( event, ui )
			{
				var id = ui.newPanel.attr('id');
				
				// read excluded urls
				if (id == 'wpex-replace-tab-excludes' && modifiedExcludeList)
				{
					callAjax(
					{
						action: 'wpex_replace_get_excluded_search_urls'
					},
					function(response)
					{
						$('#'+id).html(response.html);
						modifiedExcludeList = false;
					});
				}
			}
		});
		
		// read all urls from database
		$('#wpex-replace-string-tools #btn-search-urls').click(function()
		{
			$('#wpex-replace-string-tools .list-search-urls').slideUp();
			callAjax(
			{
				action: 'wpex_replace_search_urls'
			},
			function(response)
			{
				$('#wpex-replace-string-tools .list-search-urls').html(response.html).slideDown();
				updateSearchList();
			});			
		});

		// add url to exclude list
		$('#wpex-replace-string-tools .list-search-urls .row input.add').live('click', function()
		{
			var row = $(this).parents('.row:first');
			var url = row.find('#text_'+row.attr('id'));
		
			callAjax(
			{
				action: 'wpex_replace_exclude_search_url',
				url: url.val()
			},
			function(response)
			{
				row.slideUp('fast', function()
				{
					row.remove();
					updateSearchList();
				});
			});			
		});

		// remove url from exclude list
		$('#wpex-replace-excludeed-urls .row input.remove').live('click', function()
		{
			var row = $(this).parents('.row:first');
			var url = row.find('#text_'+row.attr('id'));
		
			callAjax(
			{
				action: 'wpex_replace_include_search_url',
				url: url.val()
			},
			function(response)
			{
				row.slideUp('fast', function()
				{
					row.remove();
					updateExcludeList();
				});
			});			
		});

		// replace strings
		$('.list-search-urls #btnreplaceurls').live('click', function()
		{
			var regex = /([^\[]+)\[([^\]]+)\]=([^;]+);/gi;
			var error = '';
			var data = [];
			var urls = $('.list-search-urls div.replacing-urls div.row');
			urls.each(function()
			{
				var oldText = $(this).find("[id*='text_']");
				var newText = $(this).find("[id*='newtext_']");
				var oldValue = oldText.val().trim();
				var newValue = newText.val().trim();
				if (newValue == '')
					return true;
				
				// remove trailing slash
				if (newValue[newValue.length-1] == '/')
					newValue = newValue.substr(0, newValue.length-1); 
					
				// check it's a valid url
				if (!checkUrl(newValue))
				{
					error += wpxe_replace_i18n.invalid_url.replace(/{url}/, newValue) + "\n";
					return true;
				}

				// ignore if the url is the same
				if (oldValue.toLowerCase() == newValue.toLowerCase())
				{
					return true;
				}
				
				data.push(
				{
					oldText: oldValue,
					newText: newValue,
					ids: oldText.attr('ids')
				});
			
				return true;
			});
			
			if (error.length > 0)
			{
				alert(error);
				return;
			}

			if (data.length == 0)
			{
				$('#wpex-replace-string-tools .list-search-urls').slideUp('fast', function()
				{
					$(this).html(wpxe_replace_i18n.no_urls_replaced).slideDown('slow');
				});
				return;
			}

			$('#wpex-replace-string-tools .list-search-urls').slideUp();			
			callAjax(
			{
				action: 'wpex_replace_replace_strings',
				data: data
			},
			function(response)
			{
				$('#wpex-replace-string-tools .list-search-urls').html(response.html).slideDown();
			});		
		});
  });	
});
/*]]>*/ 